unit repeats;
{
  QuickReport 2.0 for Delphi 1.0/2.0/3.0

  Example work around to repeat group headers

  A simple example to show a work around that allows you to repeat group
  bands on page breaks.  The way around this is to use child bands on the
  page hader band that duplicate the layout of the group header bands.

  Please note that this report will not work correctly when previewed at
  design time.  This requires the BeforePrint events to do the work around
  and you will not see it working until you actually run the report.

  This report has two group header bands and each header is "mirrored" with
  a matching child band connected to the Pageheader band.
}

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, quickrpt, Db, DBTables, Qrctrls;

type
  TfrmRepeatHeader = class(TForm)
    QuickRep1: TQuickRep;
    Query1: TQuery;
    DetailBand1: TQRBand;
    QRGroup1: TQRGroup;
    QRGroup2: TQRGroup;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    PageHeaderBand1: TQRBand;
    ChildBand1: TQRChildBand;
    ChildBand2: TQRChildBand;
    RepeatCompany: TQRLabel;
    RepeatOrderNo: TQRLabel;
    Query1orderno: TFloatField;
    Query1custno: TFloatField;
    Query1SaleDate: TDateTimeField;
    Query1ShipDate: TDateTimeField;
    Query1EmpNo: TIntegerField;
    Query1ShipToContact: TStringField;
    Query1ShipToAddr1: TStringField;
    Query1ShipToAddr2: TStringField;
    Query1ShipToCity: TStringField;
    Query1ShipToState: TStringField;
    Query1ShipToZip: TStringField;
    Query1ShipToCountry: TStringField;
    Query1ShipToPhone: TStringField;
    Query1ShipVIA: TStringField;
    Query1PO: TStringField;
    Query1Terms: TStringField;
    Query1PaymentMethod: TStringField;
    Query1ItemsTotal: TCurrencyField;
    Query1TaxRate: TFloatField;
    Query1Freight: TCurrencyField;
    Query1AmountPaid: TCurrencyField;
    Query1orderno_1: TFloatField;
    Query1ItemNo: TFloatField;
    Query1PartNo: TFloatField;
    Query1Qty: TIntegerField;
    Query1Discount: TFloatField;
    Query1custno_1: TFloatField;
    Query1Company: TStringField;
    Query1Addr1: TStringField;
    Query1Addr2: TStringField;
    Query1City: TStringField;
    Query1State: TStringField;
    Query1Zip: TStringField;
    Query1Country: TStringField;
    Query1Phone: TStringField;
    Query1FAX: TStringField;
    Query1TaxRate_1: TFloatField;
    Query1Contact: TStringField;
    Query1LastInvoiceDate: TDateTimeField;
    QRSysData1: TQRSysData;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    procedure ChildBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure DetailBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure ChildBand2BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRepeatHeader: TfrmRepeatHeader;

implementation

{$R *.DFM}

procedure TfrmRepeatHeader.DetailBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
{
  In the detail band, set the captions on the pageheader child bands.  This
  is how we will know when to print the child bands on a page break.  If a new
  group starts on the next page, we can compare the current record with the
  saved groups.  If they don't match, we skip the child band.
}
  RepeatCompany.Caption := Query1Company.AsString;
  RepeatOrderNo.Caption := Query1OrderNo.AsString;
end;

procedure TfrmRepeatHeader.ChildBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
{
  We only print the child band after the first page and when the the next
  detail band to be printed is in this group.
}
  PrintBand := (QuickRep1.PageNumber > 1) and
    (RepeatCompany.Caption = Query1Company.AsString);
end;

procedure TfrmRepeatHeader.ChildBand2BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  PrintBand := (QuickRep1.PageNumber > 1) and
    (RepeatOrderNo.Caption = Query1OrderNo.AsString);
end;

end.
